#include <stdio.h>
#include <math.h>

void CL(void);
void rc(void);
void lc(void);
void LL(void);
void cl(void);
void CC(void);
void RL(void);
void LR(void);
void LC(void);

int main()
{
    int joonis;
    printf("Esimene t2ht n2itab horisontaal elementi,\nteine n2itab vertikaal elementi,\nv2ikeste t2htedega on vertikaalne element vasakul,\nsuurte t2htedega on horisontaal element vasakul.\n\n");
    printf("T2htis! \nC - nano\nR - kilo\nL - milli\nW(omega?) - krad/s");
    do{
        printf("\n\nJoonis:\n");
        printf("[1]CL\n[2]rc\n[3]lc\n[4]LL\n[5]LR\n[6]LC\n[7]cl\n[8]CC\n[9]RL\n[0]l6peta\n");
        scanf("%d", &joonis);

        switch(joonis){
            case 1:
                CL();
                break;
            case 2:
                rc();
                break;
            case 3:
                lc();
                break;
            case 4:
                LL();
                break;
            case 5:
                LR();
                break;
            case 6:
                LC();
                break;
            case 7:
                cl();
                break;
            case 8:
                CC();
                break;
            case 9:
                RL();
                break;
            default:
                break;
        }


    }while(joonis != 0);
    return 0;
}

double sisestus(char param)
{
    double x;
    printf("Sisestage %c:\n", param);
    scanf("%lf", &x);
    return x;
}

void CL(void)
{
    double C;
    double L;
    double W;

    double Xc;
    double Xl;
    double V;

    C = sisestus('C');
    L = sisestus('L');
    W = sisestus('W');

    Xc = (1 / (W * pow(10,3) * C * pow(10,-9)));
    Xl = W *L;
    V = Xl - Xc;

    printf("Db = %0.2lf", 20 * log10(Xl / V));
}

void rc(void)
{
    double C;
    double R;
    double W;

    double Xc;
    double Z;

    C = sisestus('C');
    R = sisestus('R');
    W = sisestus('W');

    Xc = (1 / (W * pow(10,3) * C * pow(10,-9))) / 1000;
    Z = sqrt(pow(R, 2) + pow(Xc, 2));

    printf("Db = %0.2lf", 20 * log10(R / Z));
}

void lc(void)
{

    double C;
    double L;
    double W;

    double Gl;
    double Gc;
    double G;

    C = sisestus('C');
    L = sisestus('L');
    W = sisestus('W');

    Gl = (1 / (W * L));
    Gc = W * pow(10,3) * C * pow(10,-9);
    G = Gc - Gl;

    printf("Db = %0.2lf", 20 * log10(Gc / G));
}

void LL(void)
{

    printf("Db = %0.2lf", -6.0);
}

void cl(void)
{
    double C;
    double L;
    double W;

    double Gl;
    double Gc;
    double G;

    C = sisestus('C');
    L = sisestus('L');
    W = sisestus('W');

    Gl = (1 / (W * L));
    Gc = W * pow(10,3) * C * pow(10,-9);
    G = Gc - Gl;


    printf("Db = %0.2lf", 20 * log10(Gl / G));
}

void CC(void)
{
    printf("Db = %0.2lf", -6.0);
}

void RL(void)
{
    double L;
    double R;
    double W;

    double Xl;
    double Z;

    L = sisestus('L');
    R = sisestus('R');
    W = sisestus('W');

    Xl = W *L;
    Z = sqrt(pow(R, 2) + pow(Xl, 2));

    printf("Db = %0.2lf", 20 * log10(Xl / Z));
}

void LR(void)
{
    printf("R on oomides, mitte kilooomides!");
    double L;
    double R;
    double W;

    double Kv;

    L = sisestus('L');
    R = sisestus('R');
    W = sisestus('W');

    Kv = (R / (sqrt(pow(R, 2) + pow(W * L, 2))));

    printf("Db = %0.2lf", 20 * log10(Kv));
}

void LC(void)
{
    double L;
    double C;
    double W;

    double Kv;

    L = sisestus('L');
    C = sisestus('C');
    W = sisestus('W');

    Kv = fabs(1 / (1 - pow(W*1000, 2) * L * pow(10, -3) * C * pow(10, -9)));

    printf("Db = %0.2lf", 20 * log10(Kv));
}
