#include <stdio.h>
#include <math.h>

#define PI 3.14159265358979323846

double sisestus(char);
void RC(void);
void LC(void);

int main(void)
{
    int x;
    printf("[1]RC: R - kilo, C - mikro, f - kilo /t Vastus on oomides!\n");
    printf("[2]LC: L - mikro, C - mikro, f - kilo /t Vastus on oomides!\n");
    scanf("%d", &x);
    do
    {

        if(x == 1) {RC();}
        else if (x == 2){LC();}
        printf("Kirjutage 1, et teha RC arvutus, 2, et teha LC arvutus. Kirjutage 0, et lahkuda!\n");
        scanf("%d", &x);

    }while(x != 0);
}

void RC(void)
{
    double f = sisestus('f');
    double R = sisestus('R');
    double C = sisestus('C');

    printf("%0.0lf-j%0.0lf\n", 1000*((1/R)/(pow(1/R,2) + pow(2*PI*f*C, 2))), 1000*((2*PI*f*C) / (pow(1/R,2) + pow(2*PI*f*C, 2))));
}

void LC(void)
{
    double f = sisestus('f');
    double L = sisestus('L');
    double C = sisestus('C');

    double Xl = 2 * PI * f * pow(10, 3) * L * pow(10, -6); /// 0+jXL _ 1/Xl = 0-j(1/XL)
    double Xc = 1 / (2 * PI * f * pow(10, 3) * C * pow(10, -9)); /// 0-jXc _ 1/Xc = 0+j(1/Xc)
    double Z = (1 / Xc) - (1 / Xl);
    if(Z < 0)
    {
        printf("0+j%0.0lf\n", -1*Z / pow(Z, 2));
    } else {
        printf("0-j%0.0lf\n", Z / pow(Z, 2));
    }

}

double sisestus(char param)
{
    double x;
    printf("Sisestage %c:\n", param);
    scanf("%lf", &x);
    return x;
}
